from osv import osv, fields
from tools import DEFAULT_SERVER_DATE_FORMAT
from datetime import datetime


# Service Wait
class service_wait(osv.osv):
    _name = "service.wait"
    _description = "Wait"
    _order = "date_start desc"

    _columns = {
        'name': fields.char('Description', size=256),
        'reason': fields.many2one('service.wait.reason', 'Reason'),
        'user_id': fields.many2one('res.users', 'User'),
        'date_start': fields.date('Date start'),
        'date_end': fields.date('Date end'),
        'customer_wait': fields.related(
            'reason', 'customer_wait', type='boolean',
            string="Customer Wait", store=True, readonly=True),
        'state': fields.selection(
            [('waiting', 'Waiting'),
             ('finished', 'Finished')],
            'State', readonly=True, select=True),
        'order_id': fields.many2one('service.order', 'Service Order')
    }
    _defaults = {
        'state': 'waiting',
        'date_start': fields.datetime.now,
        'user_id': lambda self, cr, uid, context: uid,
    }

    def mark_finished(self, cr, uid, ids, context=None):
        write_vals = {
            'state': 'finished',
            'date_end': datetime.strftime(datetime.today(),
                                          DEFAULT_SERVER_DATE_FORMAT)
        }
        self.write(cr, uid, ids, write_vals, context)


class service_wait_reason(osv.osv):
    _name = "service.wait.reason"
    _description = "Wait Reason"

    _columns = {
        'name': fields.char('Reason', size=64),
        'customer_wait': fields.boolean('Customer Wait')
    }

    _defaults = {
        'customer_wait': lambda *x: False,
    }
